PROCEDURE vga_setpalette(VAR pal:VBE_VESAPalette;first,count:word);
  VAR pos:  longint := 0;
BEGIN
  port[$3c8] := first;
  FOR pos := 0 TO (count-1) DO
  BEGIN
    port[$3c9] := pal^[first+pos,rchn];
    port[$3c9] := pal^[first+pos,gchn];
    port[$3c9] := pal^[first+pos,bchn];
  END;
END;

PROCEDURE createpal_rgb8(VAR pal:VBE_VESAPalette;DACWidth:word);
 VAR r,g,b: longint := 0;
  FOR r := 0 TO 7 DO
    FOR g := 0 TO 3 DO
      FOR b := 0 TO 7 DO
      BEGIN
        pal^[(r shl 5)+(g shl 3)+b,bchn] := round((DACWidth/7)*r);
        pal^[(r shl 5)+(g shl 3)+b,gchn] := round((DACWidth/3)*g);
        pal^[(r shl 5)+(g shl 3)+b,rchn] := round((DACWidth/7)*b);
      END;

PROCEDURE createpal_gray8(VAR pal:VBE_VESAPalette;DACWidth:word);
 VAR count: longint := 0;
BEGIN
  FOR count := 0 TO 191 DO
  BEGIN
    pal^[count,bchn] := round((DACWidth/191)*count);
    pal^[count,gchn] := round((DACWidth/191)*count);
    pal^[count,rchn] := round((DACWidth/191)*count);
  END;

  FOR count := 192 TO 255 DO
  BEGIN
    pal^[count,bchn] := 255;
    pal^[count,gchn] := 255;
    pal^[count,rchn] := 255;
  END;
END;

PROCEDURE createpal_dither(VAR pal:VBE_VESAPalette;DACWidth:word);
 VAR i: longint := 0;
  FOR i := 0 TO 255 DO
  BEGIN
    pal^[i,bchn] := round(((i AND $E0) SHR 5) * (DACWidth/7.0));
    pal^[i,gchn] := round(((i AND $1C) SHR 2) * (DACWidth/7.0));
    pal^[i,rchn] := round((i AND $03) * (DACWidth/3.0));
  END;

PROCEDURE wait_for_vertical_retrace;
ASM
  mov  dx, $3DA

@@low:
  in   al, dx
  and  al, $08
  jnz  @@low

@@high:
  in  al,   dx
  and al,   $08
  jz  @@high
END;

